/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package foobar;

import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.script.ScriptException;

/**
 *
 * @author Administrator
 */
public class Door implements Enterable{
    private Map<String, Room> member = new ConcurrentHashMap<String, Room>(2);
    
    public void add(Room room) {
        member.put(room.getName(), room);
    }

    public Room getAnotherRoom(Room room) {
        for(Entry e :member.entrySet()){
            if (!e.getKey().equals(room.getName())) {
                return (Room) e.getValue();
            }
        }
        return null;
    }

    public boolean enter(Ninny ninny) {
        Room currentRoom = ninny.getOwner();
        // 玩家在当前门所在的房间
        if(!member.containsKey(currentRoom.getName())) {
            return false;
        }
        // 门另一侧的房间
        Room nextRoom = getAnotherRoom(currentRoom);
        
        try {
            Script script = new Script();
            script.put("room1", currentRoom);
            script.put("room2", nextRoom);
            script.put("door", this);
            script.put("player", ninny);
            script.eval("enterDoor");
            System.out.println("enterDoor: " + script.get("message"));
            return Boolean.valueOf(script.get("result").toString());
        } catch (ScriptException ex) {
            Logger.getLogger(Door.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }        
    }

    public boolean exit(Ninny ninny) {
        // 门能进就能出，玩家不会被卡在门上
        return true;
    }    
}
