/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package foobar;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.script.ScriptException;

/**
 *
 * @author Administrator
 */
public class Room implements Enterable{
    private Map<String, Ninny> member = new ConcurrentHashMap<String, Ninny>();
    private String name = null;

    public Room(String roomName) {
        name = roomName;
    }

    public String getName() {
        return name;
    }

    public void addNinny(Ninny ninny) {
        ninny.setOwner(this);
        member.put(ninny.getName(), ninny);
    }

    public void removeNinny(Ninny ninny) {
        ninny.setOwner(null);
        member.remove(ninny.getName());
    }

    public boolean enter(Ninny ninny) {
        try {
            Script script = new Script();
            script.put("room", this);
            script.put("player", ninny);
            script.eval("enterRoom");
            System.out.println("enterRoom: " + script.get("message"));
            return Boolean.valueOf(script.get("result").toString());
        } catch (ScriptException ex) {
            Logger.getLogger(Door.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }      
    }

    public boolean exit(Ninny ninny) {
        try {
            Script script = new Script();
            script.put("room", this);
            script.put("player", ninny);
            script.eval("exitRoom");
            System.out.println("exitRoom: " + script.get("message"));
            return Boolean.valueOf(script.get("result").toString());
        } catch (ScriptException ex) {
            Logger.getLogger(Door.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }      
    }
}
